Subject: Re: [PATCH iproute2 net-next v2 3/4] ss: Buffer raw fields first, then render them as a table

From: Stefano Brivio <[email-masked]>
Date: Wed, 13 Feb 2019 18:22:55 +0100

On Wed, 13 Feb 2019 08:51:01 -0800
Stephen Hemminger <[email-masked]> wrote:

> On Wed, 13 Feb 2019 09:37:11 +0100
> Stefano Brivio <[email-masked]> wrote:
> 
> > On Tue, 12 Feb 2019 16:42:04 -0800
> > Eric Dumazet <[email-masked]> wrote:
> >   
> > > I do not get it.
> > > 
> > > "ss -emoi " uses almost 1KB per socket.
> > > 
> > > 10,000,000 sockets -> we need about 10GB of memory  ???
> > > 
> > > This is a serious regression.    
> > 
> > I guess this is rather subjective: the worst case I considered back then
> > was the output of 'ss -tei0' (less than 500 bytes) for one million
> > sockets, which gives 500M of memory, which should in turn be fine on a
> > machine handling one million sockets.
> > 
> > Now, if 'ss -emoi' on 10 million sockets is an actual use case (out of
> > curiosity: how are you going to process that output? Would JSON help?),
> > I see two easy options to solve this:
> > 
> > 1. flush the output every time we reach a given buffer size (1M
> >    perhaps). This might make the resulting blocks slightly unaligned,
> >    with occasional loss of readability on lines occurring every 1k to
> >    10k sockets approximately, even though after 1k sockets column sizes
> >    won't change much (it looks anyway better than the original), and I
> >    don't expect anybody to actually scroll that output
> > 
> > 2. add a switch for unbuffered output, but then you need to remember to
> >    pass it manually, and the whole output would be as bad as the
> >    original in case you need the switch.
> > 
> > I'd rather go with 1., it's easy to implement (we already have partial
> > flushing with '--events') and it looks like a good compromise on
> > usability. Thoughts?
> >   
> I agree with eric. The benefits of buffering are not worth it.
> Let's just choose a reasonable field width, if something is too big, columns won't line up
> which i snot a big deal.

That's how it was before, and we couldn't even get fields aligned with
TCP and UDP sockets in a 80 columns wide terminal. See examples at:
https://patchwork.ozlabs.org/cover/847301/.

I tried, but I think it's impossible to find a "reasonable" field
width, especially when you mix a number of socket types.

> Unless you come up with a better solution, I am going to revert this.

That's why I asked for feedback about my proposals 1. and 2. above.
I'll go for 1. then.

-- 
Stefano